<?php

class EwayGatewayForwarder extends AbstractGatewayForwarder {
    public $settings = array(
        'customer_id'       => '',
        'username'          => '',
        'amount'            => '',
        'currency'          => '',
        'page_title'        => '',
        'page_description'  => '',
        'page_footer'       => '',
        'company_name'      => '',
        'cancel_url'        => '',
        'ewayurl'           => '',
        'generic_secret'    => '',
        'thankyou_url'      =>'',
        'eway_t'            => 'shared'
    );
    public function __construct() {
        parent::__construct();
    }
    public function handle() {
    	if (isset($_GET['sess_start']) && $_GET['sess_start'] == 'true') {
    		$cleaned = $_GET;
            if(get_magic_quotes_gpc()) {
                $cleaned = stripslashes_deep($cleaned);
            }
            $this->settings = array_merge($this->settings, $cleaned);
            // Store the settings
            $auth = $this->create_session($this->settings);
            echo json_encode($this->get_auth_url($auth, '&eway_t='.$this->settings['eway_t']));
            WLMGatewayDebug::write("Session started", $auth);
        } elseif(isset($_GET['auth']) && !empty($_GET['auth'])) {
            $this->settings = $this->get_session_settings($_GET['auth']);
            if($this->settings === false) {
                throw new Exception("Invalid Session");
            }
            $handler = null;
            if($this->settings['eway_t'] == 'shared') {
                $handler = new EwaySharedPaymentGatewayProcessor($_GET['auth'], $this->settings, $this);
            } else {
                $handler = new EwayRecurringGatewayProcessor($_GET['auth'], $this->settings, $this);
            }
            // now delegate the responsibility
            $handler->process();
        }
    }
}

