<?php
abstract class EwayPaymentProcessor {
    protected $settings;
    protected $forwarder;
    protected $session_auth;
    protected $is_test = false;
    public function __construct($auth, $settings = array(), $forwarder = null) {
        $this->session_auth = $auth;
        $this->settings = $settings;
        $this->forwarder = $forwarder;
        if($this->settings['test_mode'] == 'NO') {
            $this->is_test = false;
        } else {
            $this->is_test = true;
        }
    }
    function clear_session() {
        $this->forwarder->clear_session($this->session_auth);
    }

    abstract function process();
}