<?php
class EwaySharedPaymentGatewayProcessor extends EwayPaymentProcessor {
    private $req_url = "https://au.ewaygateway.com/Request/";
    private $resp_url = "https://au.ewaygateway.com/Result/";
    public function __construct($auth, $settings = array(), $forwarder = null) {
        parent::__construct($auth, $settings, $forwarder);
    }
    function process() {
    	$act = 'showform';
        if(isset($_GET['m']) && !empty($_GET['m'])) {
            $act = $_GET['m'];
        }

        switch($act) {
            case 'readresp':
                $res = $this->get_payment_reponse($_POST['AccessPaymentCode']);
                WLMGatewayDebug::write("Read response: ".serialize($res));
                $status  = strtolower($this->parse_data($res, '<trxnstatus>', '</trxnstatus>'));
                $sctxnid = $this->parse_data($res, '<trxnnumber>', '</trxnnumber>');
                $sctxnid = 'EWAYOP-'.$sctxnid;
                if($status == 'true') {
                    $data['cmd']        = 'CREATE';
                    $data['firstname'] = 'first_name';
                    $data['lastname']  = 'last_name';
                    $data['username']   = 'changeme'.time();
                    $data['email']      = 'changeme'.time().'@'.'temp.mail';
                    $data['level']      = $this->settings['wlm_sku'];
                    $data['transaction_id'] = $sctxnid;
                    $data['hash']       =   md5('CREATE__' . $this->settings['generic_secret']
                            . '__' . strtoupper(implode('|', $data)));
                    $request = new Curl();
                    $response = $request->simple_post($this->settings['wlm_postback'], $data);
                    WLMGatewayDebug::write($response);
                    list($status, $url) = explode("\n", $response);
                    $this->clear_session();
                    header("Location: $url");
                } else {
                    $this->clear_session();
                    header("Location: ".$this->settings['wlm_cancel_postback']);
                }
                break;
            case 'cancel':
                header("Location: ".$this->settings['wlm_cancel_postback']);
                break;
            default:
                if(empty($this->settings['amount']) || $this->settings['amount'] <= 0) {
                    throw new Exception("Invalid Amount");
                }
                $payment_url = $this->get_payment_url();
                if(empty($payment_url)) {
                    header("Location: ".$this->settings['wlm_cancel_postback']);
                }
                header("Location: $payment_url");
                break;
        }
    }
    function parse_data($string, $start_tag, $end_tag) {
        $position = stripos($string, $start_tag);
        $str = substr($string, $position);
        $str_second = substr($str, strlen($start_tag));
        $second_positon = stripos($str_second, $end_tag);
        $str_third = substr($str_second, 0, $second_positon);
        $fetch_data = trim($str_third);
        return $fetch_data;
    }
    function get_payment_reponse($auth) {
        extract($this->settings);
        $q = "CustomerID=$customer_id"
            ."&UserName=$username"
            ."&AccessPaymentCode=$auth";
        $req = sprintf("%s?%s", $this->resp_url, $q);

        $request = new Curl();
        $request->ssl(false);
        $response = $request->simple_get($req);

        if(!empty($response)) {
            return $response;
        }
        return false;
    }
    function get_payment_url() {
        extract($this->settings);
        $return_url = urlencode($this->forwarder->app_base_url."index.php?t=EwayGatewayForwarder&auth=$this->session_auth&m=readresp");
        $cancel_url = urlencode($this->forwarder->app_base_url."index.php?t=EwayGatewayForwarder&auth=$this->session_auth&m=cancel");
        $ewayurl.="?CustomerID=$customer_id"
        ."&UserName=$username"
        ."&Amount=".number_format($amount, 2)
        ."&Currency=$currency"
        ."&PageTitle=$page_title"
        ."&PageDescription=$page_description"
        ."&PageFooter=$page_footer"
        ."&Language="
        ."&CompanyName=$company_name"
        ."&CustomerFirstName="
        ."&CustomerLastName="
        ."&CustomerAddress="
        ."&CustomerCity="
        ."&CustomerState="
        ."&CustomerPostCode="
        ."&CustomerCountry="
        ."&CustomerEmail="
        ."&CustomerPhone="
        ."&InvoiceDescription=$invoice_description"
        ."&CancelURL=$cancel_url"
        ."&ReturnUrl=$return_url"
        ."&CompanyLogo=$company_logo"
        ."&PageBanner=$page_banner"
        ."&MerchantReference="
        ."&MerchantInvoice="
        ."&MerchantOption1="
        ."&MerchantOption2="
        ."&MerchantOption3="
        ."&ModifiableCustomerDetails=true";
        $spacereplace = str_replace(" ", "%20", $ewayurl);
        $req = $this->req_url.$spacereplace;
        $request = new Curl();
        $request->ssl(false);

        WLMGatewayDebug::write("Sent: $req", $this->session_auth);
        $response = $request->simple_get($req);
        WLMGatewayDebug::write("Received: ".serialize($response), $this->session_auth);

        if(empty($response)) {
            return false;
        }

        $response_result	= $this->parse_data($response, '<result>', '</result>');
        $response_url		= $this->parse_data($response, '<uri>', '</uri>');

        if(strtolower(trim($response_result)) == 'true') {
            return trim($response_url);
        }
        return false;
    }
}